// (C) 2001 SyGem Software

import java.awt.*;
import java.applet.*;

import com.sygem.jazz3d3.*;
import com.sygem.jazz3d3.primitive.Torus3d;

public class fire extends Applet implements Runnable {
        Thread m_ce;
        World myWorld;
        int light1;
        int pid;
		boolean stat = false;
		int rand = 3;

		Texture t2;
		int[] r = new int[64*64];
		int[] g = new int[64*64];
		int[] firepal = new int[256];

        int downx = 0;
        int downy = 0;
        double ddx = 0;
        double ddy = 0;
        boolean down = false;

		boolean antialias = false;
		boolean bilinear = false;

        //Construct the applet
        public fire() {
        }

        //Initialize the applet
        public void init() {

                myWorld = new World(this);
                setLayout(new BorderLayout());
                add("Center",myWorld);

				t2 = new Texture(Texture.VSMALL);

				seedFire();
				buildFirePalette();
				myWorld.setBackground(t2);

                RenderTextured tex = new RenderTextured();
                tex.setTexture(t2);
                tex.setDrawingMode(Render.FLAT);

                Torus3d sp1 = new Torus3d(0.5,0.2,0.2,15,15,0,0,8);
                sp1.setRenderer(tex);

                pid = myWorld.addObject(sp1);

                Light l1 = new Light(0,0,1);
                myWorld.addLight(l1);

        }

        //Start the applet
        public void start() {
                if (m_ce == null) {
                        m_ce = new Thread(this);
                        m_ce.start();
                }
        }

        //Stop the applet
        public void stop() {
                if (m_ce != null) {
                        m_ce.stop();
                        m_ce = null;
                }
        }

        //Destroy the applet
        public void destroy() {
        }

        public void run() {
                int iCount = 0;
                long lTime0 = System.currentTimeMillis();
                double z;
                ddx = 0.16;
                ddy = 0.35;
                z = 0.21;
                myWorld.prep();

                while (true) {
						seedFire();
						extendFlame();
                        myWorld.getParentObject(pid).rotateWorld(ddy,ddx,z);
                        myWorld.prepareCanvas();
                        t2.setTextureArray(fireArray());
                        myWorld.updateBackgroundImage();
                        myWorld.generateImage();
                        myWorld.drawImage();
                        myWorld.finishCanvas();
                        iCount++;
                        if((iCount%50) == 0) {
                                lTime0-= System.currentTimeMillis();
                                lTime0 =-lTime0;
                                getAppletContext().showStatus((50000./lTime0)+" frames/second");
                                lTime0 = System.currentTimeMillis();
                        }
                }
        }

        public boolean mouseDown(Event evt, int x, int y) {
			downx = x;
			downy = y;
			down = true;
			return true;
		}

        public boolean mouseUp(Event evt, int x, int y) {
			down = false;
			return true;
		}

		public boolean mouseDrag(Event evt, int x, int y) {
			if (down) {
				double dx = x - downx;
				double dy = y - downy;
				ddx = (dx / (this.size().width))*10.0;
				ddy = (dy / (this.size().height))*10.0;
			}
			return true;
		}

		public boolean keyDown(Event evt,int key) {

			if ((char)key=='a') {antialias=!antialias; myWorld.setAntiAliasing(antialias); return true; }
			if ((char)key=='b') {bilinear=!bilinear; myWorld.setBilinear(bilinear); return true; }

			return true;
		}

		void extendFlame() {
			int index = 4030;
			byte col;
			for (int i=62;i>=0;i--) {
				rand = (int)(Math.random() * 4)+2;
				for (int j=62;j>0;j--) {
					index = (i*64) + j;
					col = (byte)((g[index+64] + g[index+63] + g[index+65] + g[index]) >> 2);
					if (index%rand==0) col -= 1;
					if (col>127) col=(byte)127;
					if (col<0) col=0;
					g[index] = col;
				}
			}
		}

		void seedFire() {
			g[4063] = 110;//(byte)((Math.random() * 27) + 100); // an initial, quite high value...
			int start = 4063;
			for (int i = 0; i < 32; i++) {
				byte t = (byte)(g[start+i] + (byte)((Math.random() * 20) - 12));
				byte t2 = (byte)(g[start-i] + (byte)((Math.random() * 20) - 12));
				g[start+i+1] = (t > 127) ? 127 : ((t<65) ? 65 : t);
				g[start-i-1] = (t2 > 127) ? 127 : ((t2<65) ? 65 : t2);
			}
		}

		int[] fireArray() {
			for (int i=0;i<g.length;i++) {
				int col = firepal[g[i]];
				r[i] = col;
			}
			return r;
		}

		void buildFirePalette() {
    		for (int x=1; x<=32; x++) {
        		firepal[x-1] =  c(x*8-1, 0,     0    );       /* red */
        		firepal[x+32-1] = c(255, x*8-1,   0   );
        		firepal[x+64-1] = c(255,   255,   x*8-1);
        		firepal[x+96-1] = c(255,   255,    255);
    		}
		}

		int c(int rr, int g, int b) {
			return rr<<16 | g<<8 | b;
		}


}