// (C) 2001 SyGem Software

import java.awt.*;
import java.applet.*;

import com.sygem.jazz3d3.*;
import com.sygem.jazz3d3.primitive.Cube3d;

public class multiTexturedReal extends Applet implements Runnable {

        Thread m_ce;
        World myWorld;
        int light1;
        int pid;

        int downx = 0;
        int downy = 0;
        double ddx = 0;
        double ddy = 0;
        boolean down = false;

		boolean antialias = false;
		boolean bilinear = false;

        //Construct the applet
        public multiTexturedReal() {
        }

        //Initialize the applet
        public void init() {

                myWorld = new World(this);
                setLayout(new BorderLayout());
                add("Center",myWorld);
                myWorld.setDelay(1);

        }

        //Start the applet
        public void start() {
                if (m_ce == null) {
                        m_ce = new Thread(this);
                        m_ce.start();
                }
        }

        //Stop the applet
        public void stop() {
                if (m_ce != null) {
                        m_ce.stop();
                        m_ce = null;
                }
        }

        //Destroy the applet
        public void destroy() {
        }

        public void run() {
                int iCount = 0;
                long lTime0 = System.currentTimeMillis();
                double z;
                ddx = 0.16;
                ddy = 0.35;
                z = 0.21;
                myWorld.prep();
                m_ce.setPriority(Thread.MAX_PRIORITY);

				painter(1);
				Texture t1 = TextureLoader.loadImage("images/Metal.gif");
				painter(2);
				Texture t2 = TextureLoader.loadImage("images/Jazz3D_logo_large.gif");
				t2.setTransparentColour(16777215);

                RenderMultiTextured tex = new RenderMultiTextured();
                tex.setDrawingMode(Render.NOSHADE);
                int t = tex.setTextureBank1(t1);
                int tt = tex.setTextureBank2(t2);
                tex.setMode(RenderMultiTextured.ADD);

                Cube3d sp1 = new Cube3d(0,0,8);
                sp1.setRenderer(tex);
                pid = myWorld.addObject(sp1);

                Light l1 = new Light(0,0,1);
                myWorld.addLight(l1);

				myWorld.prepNewObjects();

                while (true) {

                        myWorld.getParentObject(pid).rotateWorld(ddy,ddx,z);
                        myWorld.redraw();
                }
        }

        void painter(int i) {
            myWorld.prepareCanvas();
            myWorld.drawImage();
            Graphics g = myWorld.getCanvas();
			g.setColor(new Color(255,0,0));
			g.drawString("Loading image "+i,20,80);
			myWorld.finishCanvas();
		}

        public boolean mouseDown(Event evt, int x, int y) {
			downx = x;
			downy = y;
			down = true;
			return true;
		}

        public boolean mouseUp(Event evt, int x, int y) {
			down = false;
			return true;
		}

		public boolean mouseDrag(Event evt, int x, int y) {
			if (down) {
				double dx = x - downx;
				double dy = y - downy;
				ddx = (dx / (this.size().width))*10.0;
				ddy = (dy / (this.size().height))*10.0;
			}
			return true;
		}

		public boolean keyDown(Event evt,int key) {

			if ((char)key=='a') {antialias=!antialias; myWorld.setAntiAliasing(antialias); return true; }
			if ((char)key=='b') {bilinear=!bilinear; myWorld.setBilinear(bilinear); return true; }

			return true;
		}

}